Package com.io7m.waxmill.machines

# Class WXMBootConfigurationGRUBBhyve

java.lang.Object
com.io7m.waxmill.machines.WXMBootConfigurationGRUBBhyve

All Implemented Interfaces:
  `WXMBootConfigurationType`, `WXMBootConfigurationType.WXMBootConfigurationGRUBBhyveType`

    public final class WXMBootConfigurationGRUBBhyve
    extends java.lang.Object
    implements WXMBootConfigurationType.WXMBootConfigurationGRUBBhyveType

A boot configuration that uses grub-bhyve.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type | Class | Description
  --- | --- | ---
  `static class` | `WXMBootConfigurationGRUBBhyve.Builder` | Builds instances of type `WXMBootConfigurationGRUBBhyve`.

  ## Nested classes/interfaces inherited from interface com.io7m.waxmill.machines.WXMBootConfigurationType

  `WXMBootConfigurationType.Kind, WXMBootConfigurationType.WXMBootConfigurationGRUBBhyveType, WXMBootConfigurationType.WXMBootConfigurationUEFIType, WXMBootConfigurationType.WXMBootDiskAttachmentType, WXMBootConfigurationType.WXMEvaluatedBootCommandsType, WXMBootConfigurationType.WXMEvaluatedBootConfigurationGRUBBhyveType, WXMBootConfigurationType.WXMEvaluatedBootConfigurationType, WXMBootConfigurationType.WXMEvaluatedBootConfigurationUEFIType, WXMBootConfigurationType.WXMGRUBKernelInstructionsType, WXMBootConfigurationType.WXMGRUBKernelLinuxType, WXMBootConfigurationType.WXMGRUBKernelOpenBSDType`

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `static WXMBootConfigurationGRUBBhyve.Builder` | `builder()` | Creates a builder for `WXMBootConfigurationGRUBBhyve`.
  `java.lang.String` | `comment()` |
  `static WXMBootConfigurationGRUBBhyve` | `copyOf​(WXMBootConfigurationType.WXMBootConfigurationGRUBBhyveType instance)` | Creates an immutable copy of a `WXMBootConfigurationType.WXMBootConfigurationGRUBBhyveType` value.
  `java.util.Map<WXMDeviceSlot,​WXMBootDiskAttachment>` | `diskAttachmentMap()` |
  `java.util.List<WXMBootDiskAttachment>` | `diskAttachments()` |
  `boolean` | `equals​(java.lang.Object another)` | This instance is equal to all instances of `WXMBootConfigurationGRUBBhyve` that have equal attribute values.
  `int` | `hashCode()` | Computes a hash code from attributes: `diskAttachments`, `comment`, `name`, `kernelInstructions`.
  `WXMBootConfigurationType.WXMGRUBKernelInstructionsType` | `kernelInstructions()` |
  `WXMBootConfigurationName` | `name()` | The unique-within-a-virtual-machine name of the boot configuration.
  `java.lang.String` | `toString()` | Prints the immutable value `WXMBootConfigurationGRUBBhyve` with attribute values.
  `WXMBootConfigurationGRUBBhyve` | `withComment​(java.lang.String value)` | Copy the current immutable object by setting a value for the `comment` attribute.
  `WXMBootConfigurationGRUBBhyve` | `withDiskAttachments​(WXMBootDiskAttachment... elements)` | Copy the current immutable object with elements that replace the content of `diskAttachments`.
  `WXMBootConfigurationGRUBBhyve` | `withDiskAttachments​(java.lang.Iterable<? extends WXMBootDiskAttachment> elements)` | Copy the current immutable object with elements that replace the content of `diskAttachments`.
  `WXMBootConfigurationGRUBBhyve` | `withKernelInstructions​(WXMBootConfigurationType.WXMGRUBKernelInstructionsType value)` | Copy the current immutable object by setting a value for the `kernelInstructions` attribute.
  `WXMBootConfigurationGRUBBhyve` | `withName​(WXMBootConfigurationName value)` | Copy the current immutable object by setting a value for the `name` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface com.io7m.waxmill.machines.WXMBootConfigurationType.WXMBootConfigurationGRUBBhyveType

  `kind, requiredDevices`

- ## Method Details

  - ### diskAttachments

    public java.util.List<WXMBootDiskAttachment> diskAttachments()
    Specified by:
      `diskAttachments` in interface `WXMBootConfigurationType`
    Returns:
      The disks attached to the virtual machine on boot

  - ### diskAttachmentMap

    public java.util.Map<WXMDeviceSlot,​WXMBootDiskAttachment> diskAttachmentMap()
    Specified by:
      `diskAttachmentMap` in interface `WXMBootConfigurationType`
    Returns:
      The disk attachments by device slot

  - ### comment

    public java.lang.String comment()
    Specified by:
      `comment` in interface `WXMBootConfigurationType`
    Specified by:
      `comment` in interface `WXMBootConfigurationType.WXMBootConfigurationGRUBBhyveType`
    Returns:
      The value of the `comment` attribute

  - ### name

    public WXMBootConfigurationName name()
    Description copied from interface: `WXMBootConfigurationType`
    The unique-within-a-virtual-machine name of the boot configuration.
    Specified by:
      `name` in interface `WXMBootConfigurationType`
    Specified by:
      `name` in interface `WXMBootConfigurationType.WXMBootConfigurationGRUBBhyveType`
    Returns:
      The value of the `name` attribute

  - ### kernelInstructions

    public WXMBootConfigurationType.WXMGRUBKernelInstructionsType kernelInstructions()
    Specified by:
      `kernelInstructions` in interface `WXMBootConfigurationType.WXMBootConfigurationGRUBBhyveType`
    Returns:
      The underlying kernel instructions

  - ### withDiskAttachments

    public final WXMBootConfigurationGRUBBhyve withDiskAttachments​(WXMBootDiskAttachment... elements)
    Copy the current immutable object with elements that replace the content of `diskAttachments`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withDiskAttachments

    public final WXMBootConfigurationGRUBBhyve withDiskAttachments​(java.lang.Iterable<? extends WXMBootDiskAttachment> elements)
    Copy the current immutable object with elements that replace the content of `diskAttachments`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of diskAttachments elements to set
    Returns:
      A modified copy of `this` object

  - ### withComment

    public final WXMBootConfigurationGRUBBhyve withComment​(java.lang.String value)
    Copy the current immutable object by setting a value for the `comment` attribute. An equals check used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for comment
    Returns:
      A modified copy of the `this` object

  - ### withName

    public final WXMBootConfigurationGRUBBhyve withName​(WXMBootConfigurationName value)
    Copy the current immutable object by setting a value for the `name` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for name
    Returns:
      A modified copy of the `this` object

  - ### withKernelInstructions

    public final WXMBootConfigurationGRUBBhyve withKernelInstructions​(WXMBootConfigurationType.WXMGRUBKernelInstructionsType value)
    Copy the current immutable object by setting a value for the `kernelInstructions` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for kernelInstructions
    Returns:
      A modified copy of the `this` object

  - ### equals

    public boolean equals​(java.lang.Object another)
    This instance is equal to all instances of `WXMBootConfigurationGRUBBhyve` that have equal attribute values.
    Overrides:
      `equals` in class `java.lang.Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `diskAttachments`, `comment`, `name`, `kernelInstructions`.
    Overrides:
      `hashCode` in class `java.lang.Object`
    Returns:
      hashCode value

  - ### toString

    public java.lang.String toString()
    Prints the immutable value `WXMBootConfigurationGRUBBhyve` with attribute values.
    Overrides:
      `toString` in class `java.lang.Object`
    Returns:
      A string representation of the value

  - ### copyOf

    public static WXMBootConfigurationGRUBBhyve copyOf​(WXMBootConfigurationType.WXMBootConfigurationGRUBBhyveType instance)
    Creates an immutable copy of a `WXMBootConfigurationType.WXMBootConfigurationGRUBBhyveType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable WXMBootConfigurationGRUBBhyve instance

  - ### builder

    public static WXMBootConfigurationGRUBBhyve.Builder builder()
    Creates a builder for `WXMBootConfigurationGRUBBhyve`.

         WXMBootConfigurationGRUBBhyve.builder()
            .addDiskAttachments|addAllDiskAttachments(WXMBootDiskAttachment) // diskAttachments elements
            .setComment(String) // optional comment
            .setName(com.io7m.waxmill.machines.WXMBootConfigurationName) // required name
            .setKernelInstructions(com.io7m.waxmill.machines.WXMBootConfigurationType.WXMGRUBKernelInstructionsType) // required kernelInstructions
            .build();

    Returns:
      A new WXMBootConfigurationGRUBBhyve builder